import java.util.ArrayList;
/**
 * Clase que almacena todos los ramos.
 */
public class malla{

    private mallaView mv;

    /**
     * Constructor de la malla. Genera el arreglo para los ramos.
     */
    public malla(){
        ramos = new ArrayList<ramo>();
    }

    /**
     * Setea la vista de malla.
     * @param mv Vista de malla. (Objeto MallaView)
     */
    public void setMallaView(mallaView mv){
        this.mv = mv;
    }

    /**
     * Obtiene la vista de malla.
     * @return  Vista de la malla.
     */
    public mallaView getMallaView(){
        return this.mv;
    }

    /**
     * Permite agregar un ramo al arreglo de la malla.
     * @param r Ramo a agregar.
     */
    public void addRamo(ramo r){
        ramos.add(r);
    }

    /**
     * Obtiene la lista de ramos, es decir, la malla.
     * @return Lista de ramos.
     */
    public ArrayList<ramo> getRamos(){
        return ramos;
    }

    /**
     * Obtiene cantidad total de créditos de la malla.
     * @return  Suma total de los créditos de la malla.
     */
    public int getTotalCredits(){
        int total = 0;
        for(int i=0 ; i < ramos.size() ; i++){
            if(!ramos.get(i).getCreditos().equals("-")){
                int cr = Integer.parseInt(ramos.get(i).getCreditos()); //obtiene creditos y transforma a int
                total+=cr;
            }
        }
        return(total);
    }

    /**
     * Obtiene el porcentaje de créditos aprobados, según los ramos marcados como aprobados.
     * @return  Porcentaje de créditos aprobados.
     */
    public double getPorcentajeCreditos(){
        int aprobados=0;
        for (int i = 0; i<ramos.size(); i++){
            if(ramos.get(i).getState()){
                aprobados+=Integer.parseInt(ramos.get(i).getCreditos());
            }
        }
        //truncar el porcentaje para desplegar con dos decimales
        double porcentaje = (aprobados * 100.0)/this.getTotalCredits();
        int temp = (int)(porcentaje*100.0);
        double p_trunc = ((double)temp)/100.0;
        return p_trunc;
    }




    private ArrayList<ramo> ramos;
}